import React, { NamedExoticComponent, ReactElement } from 'react';
import { StateExtractor } from '../stateExtracrors';
import { FieldValidationState } from '../validation/field';
import { ValidateOnChangeConfig } from '../config';
export interface FieldState<T> {
    readonly value: T;
    validation?: FieldValidationState;
}
export interface InputProps<T> extends FieldState<T> {
    handleChange: (extractorOrEvent: StateExtractor<T> | any) => void;
    validate: () => void;
}
export declare type FieldProps = {
    render: (props: any) => ReactElement | ReactElement<(props: any) => ReactElement> | NamedExoticComponent<any>;
} & {
    [propsToPassKey: string]: any;
};
export declare const createField: (name: string, validateOnChange: ValidateOnChangeConfig) => React.MemoExoticComponent<({ render, ...props }: FieldProps) => JSX.Element>;
