import { ReactElement } from 'react';
import { FormConfig } from './config';
import { FieldProps, FieldState } from './createField';
export interface FieldsState {
    [name: string]: FieldState<any>;
}
export interface FormState {
    fields: FieldsState;
    valid: boolean;
}
export interface FormMutableState {
    state: FormState;
    config: FormConfig;
    changeField: (fieldName: string, state: FieldState<any>) => void;
    reset: () => void;
    validate: () => void;
}
export interface Form extends FormMutableState {
    Fields: {
        [FieldName: string]: (props: FieldProps) => ReactElement;
    };
}
declare const useForm: (config: FormConfig) => Form;
export default useForm;
